Compress::Gzip::Writer - Crystal 1.21.0

# class Compress::Gzip::Writer

- Compress::Gzip::Writer
- IO
- Reference
- Object

##
Overview

A write-only `IO` object to compress data in the gzip format.

Instances of this class wrap another `IO` object. When you write to this instance, it compresses the data and writes it to the underlying `IO`.

NOTE unless created with a block, `#close` must be invoked after all data has been written to a `Gzip::Writer` instance.

###
Example: compress a file

    require "compress/gzip"

    File.write("file.txt", "abc")

    File.open("./file.txt", "r") do |input_file|
      File.open("./file.gzip", "w") do |output_file|
        Compress::Gzip::Writer.open(output_file) do |gzip|
          IO.copy(input_file, gzip)
        end
      end
    end

##
Defined in:

compress/gzip/writer.cr

##
Constructors

- .new(io : IO, level : Int32 = Compress::Gzip::DEFAULT_COMPRESSION, sync_close : Bool = false)

  Creates a new writer to the given io.

- .new(filename : String, level = Compress::Gzip::DEFAULT_COMPRESSION)

  Creates a new writer to the given filename.

##
Class Method Summary

- .open(io : IO, level = Compress::Gzip::DEFAULT_COMPRESSION, sync_close = false, &)

  Creates a new writer to the given io, yields it to the given block, and closes it at the end.

- .open(filename : String, level = Compress::Gzip::DEFAULT_COMPRESSION, &)

  Creates a new writer to the given filename, yields it to the given block, and closes it at the end.

##
Instance Method Summary

- #close : Nil

  Closes this writer.

- #closed? : Bool

  Returns `true` if this writer is closed.

- #flush : Nil

  Flushes data, forcing writing the gzip header if no data has been written yet.

- #header : Compress::Gzip::Header

  The header to write to the gzip stream.

- #read(slice : Bytes) : NoReturn

  Always raises `IO::Error` because this is a write-only `IO`.

- #sync_close=(sync_close : Bool)

  Whether to close the enclosed `IO` when closing this writer.

- #sync_close? : Bool

  Whether to close the enclosed `IO` when closing this writer.

- #write(slice : Bytes) : Nil

  See `IO#write`.

### Instance methods inherited from class `IO`

<<(obj : _) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(chomp : Bool = true) : String | Nil
gets(limit : Int, chomp : Bool = false) : String | Nil
gets(delimiter : Char, chomp : Bool = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string : String, args : Array | Tuple) : Nil
printf(format_string : String, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_greedy(slice : Bytes) : Int32 read_greedy, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) : Int32 read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object : _, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src : IO, dst : IO, limit : Int) : Int64
copy(src : IO, dst : IO) : Int64 copy, pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = nil, write_blocking = nil, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(io : IO, level : Int32 = Compress::Gzip::DEFAULT_COMPRESSION, sync_close : Bool = false) #

Creates a new writer to the given io.

def self.new(filename : String, level = Compress::Gzip::DEFAULT_COMPRESSION) #

Creates a new writer to the given filename.

##
Class Method Detail

def self.open(io : IO, level = Compress::Gzip::DEFAULT_COMPRESSION, sync_close = false, &) #

Creates a new writer to the given io, yields it to the given block, and closes it at the end.

def self.open(filename : String, level = Compress::Gzip::DEFAULT_COMPRESSION, &) #

Creates a new writer to the given filename, yields it to the given block, and closes it at the end.

##
Instance Method Detail

def close : Nil #

Closes this writer. Must be invoked after all data has been written.

def closed? : Bool #

Returns `true` if this writer is closed.

def flush : Nil #

Flushes data, forcing writing the gzip header if no data has been written yet.

See `IO#flush`.

def header : Compress::Gzip::Header #

The header to write to the gzip stream. It will be written just before the first write to this writer. Changes to the header after the first write are ignored.

def read(slice : Bytes) : NoReturn #

Always raises `IO::Error` because this is a write-only `IO`.

def sync_close=(sync_close : Bool) #

Whether to close the enclosed `IO` when closing this writer.

def sync_close? : Bool #

Whether to close the enclosed `IO` when closing this writer.

def write(slice : Bytes) : Nil #

See `IO#write`.